--[[
	Easily disenchant, prospect ore, or mill herbs by using the following macro:
	
#showtooltip
/script EasyDisenchant("Disenchant")
/cast Disenchant
/click EasyDisenchantButton LeftButton

]]

local labelColor = "|cff3399FF"; 	-- The label color of the chat text
local looting = false
local f = CreateFrame("Button", "EasyDisenchantButton", UIParent, "ActionButtonTemplate SecureActionButtonTemplate")
	f:RegisterForClicks("AnyUp")
	f:SetWidth(60); f:SetHeight(60)
	f:SetPoint("Center")
	f:Hide()
	f:AllowAttributeChanges()
	f:EnableMouse("false")
	f:EnableMouseWheel("false")

f:RegisterEvent("LOOT_OPENED")
f:RegisterEvent("LOOT_CLOSED")

f:SetScript("OnEvent", function(self, event, ...)
	if (event == "LOOT_OPENED") then
		looting = true
	else
		looting = false
	end
end)

function EasyDisenchant(var)
	if InCombatLockdown("player") then
		print(labelColor.."Sorry!|cffffffff You cannot use EasyDisenchant while in combat. :(")
		return
	end
	
	if UnitCastingInfo("player") or looting then return end
	
	local var = tostring(var)
	
	for i = 1, #EasyDE_item_list[var] do
		local ItemID = EasyDE_item_list[var][i]
		local count = GetItemCount(ItemID)

		if count > 0 then
			for bag = 0, 4 do              
				for slot = 1, GetContainerNumSlots(bag) do

					local link = GetContainerItemLink(bag, slot)

					if link then
						local id = tonumber(string.match(link, "item:(%d+)"))
						local stackSize = (select(2, GetContainerItemInfo(bag, slot)))
						
						if id == ItemID and not ((var == "Prospecting" or var == "Milling") and stackSize < 5) then
							local name = (select(1, GetItemInfo(id)))
							print(labelColor..var..":|cffffffff "..link.." - location: bag: "..bag..", slot: "..slot)

							f.icon = _G["EasyDisenchantButtonIcon"]
							f.icon:SetTexture((select(1, GetContainerItemInfo(bag, slot))))
							f.icon:Show()

							f:SetAttribute("type", "item")
							f:SetAttribute("target-bag", bag)
							f:SetAttribute("target-slot", slot)

							UIFrameFadeOut(f, 3, 1, 0)
							return
						end
					end
				end
			end
		end
	end
end

